/*
 * Copyright 2012 Alexander Baumgartner
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package at.jku.risc.stout.hoau;

import at.jku.risc.stout.hoau.data.InputParser;
import at.jku.risc.stout.hoau.data.TermNode;
import at.jku.risc.stout.hoau.data.NodeFactory;

/**
 * Some test cases
 * 
 * @author Alexander Baumgartner
 */
public class TestAlphaEquivalence {

	public static void main(String[] args) {
		// NodeFactory.PREFIX_IndividualVar = "$";
		test("(\\x. x f(x) x x)", "\\y. y f(y) y y");
		test("(\\y. x f(x) x y)", "x f(x) x");
		test("(\\x. x f(x) x x)", "\\y. y f(y) x y");
		test("(\\x. x f(x) x x) z", "z f(z) z z");
		test("\\x,y. x(y)", "()");
	}

	public static void test(String in1, String in2) {
		try {
			NodeFactory nf = new NodeFactory();
			TermNode n1 = new InputParser(nf, false).parseSequence(in1)
					.reduce(100);
			TermNode n2 = new InputParser(nf, false).parseSequence(in2)
					.reduce(100);
			System.out.println(n1.equals(n2) + ": " + n1 + " = " + n2);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
